-- expects (hue, saturation, value, alpha) - all between 0-1 - as input
-- returns a Factorio colour table
function hsva2rgba(h, s, v, a)
  local r, g, b
  local i = math.floor(h * 6);
  local f = h * 6 - i;
  local p = v * (1 - s);
  local q = v * (1 - f * s);
  local t = v * (1 - (1 - f) * s);
  i = i % 6
  if i == 0 then r, g, b = v, t, p
  elseif i == 1 then r, g, b = q, v, p
  elseif i == 2 then r, g, b = p, v, t
  elseif i == 3 then r, g, b = p, q, v
  elseif i == 4 then r, g, b = t, p, v
  elseif i == 5 then r, g, b = v, p, q
  end
  return { r = r, g = g, b = b, a = a }
end


function deep_add_tint (tabl)
  for key, v in pairs (tabl) do
    if type (v) == 'table' then
      if v.filename or v.tint then
        v.tint = hsva2rgba(0.0, 0.25, 1.0, 1.0)
      else
        deep_add_tint (v)
      end
    end
  end
end

deep_add_tint (data.raw)